# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from kiln_connect.openapi_client.models.eth_operation_consensus_withdrawal import ETHOperationConsensusWithdrawal
from kiln_connect.openapi_client.models.eth_operation_deposit import ETHOperationDeposit
from kiln_connect.openapi_client.models.eth_operation_execution_reward import ETHOperationExecutionReward
from typing import Any, List
from pydantic import StrictStr, Field

GETETHOPERATIONS200RESPONSEDATAINNER_ANY_OF_SCHEMAS = ["ETHOperationConsensusWithdrawal", "ETHOperationDeposit", "ETHOperationExecutionReward"]

class GetEthOperations200ResponseDataInner(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    # data type: ETHOperationDeposit
    anyof_schema_1_validator: Optional[ETHOperationDeposit] = None
    # data type: ETHOperationConsensusWithdrawal
    anyof_schema_2_validator: Optional[ETHOperationConsensusWithdrawal] = None
    # data type: ETHOperationExecutionReward
    anyof_schema_3_validator: Optional[ETHOperationExecutionReward] = None
    actual_instance: Any
    any_of_schemas: List[str] = Field(GETETHOPERATIONS200RESPONSEDATAINNER_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        error_messages = []
        # validate data type: ETHOperationDeposit
        if type(v) is not ETHOperationDeposit:
            error_messages.append(f"Error! Input type `{type(v)}` is not `ETHOperationDeposit`")
        else:
            return v

        # validate data type: ETHOperationConsensusWithdrawal
        if type(v) is not ETHOperationConsensusWithdrawal:
            error_messages.append(f"Error! Input type `{type(v)}` is not `ETHOperationConsensusWithdrawal`")
        else:
            return v

        # validate data type: ETHOperationExecutionReward
        if type(v) is not ETHOperationExecutionReward:
            error_messages.append(f"Error! Input type `{type(v)}` is not `ETHOperationExecutionReward`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetEthOperations200ResponseDataInner with anyOf schemas: ETHOperationConsensusWithdrawal, ETHOperationDeposit, ETHOperationExecutionReward. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_json(cls, json_str: str) -> GetEthOperations200ResponseDataInner:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        # anyof_schema_1_validator: Optional[ETHOperationDeposit] = None
        try:
            instance.actual_instance = ETHOperationDeposit.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[ETHOperationConsensusWithdrawal] = None
        try:
            instance.actual_instance = ETHOperationConsensusWithdrawal.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[ETHOperationExecutionReward] = None
        try:
            instance.actual_instance = ETHOperationExecutionReward.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetEthOperations200ResponseDataInner with anyOf schemas: ETHOperationConsensusWithdrawal, ETHOperationDeposit, ETHOperationExecutionReward. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

