# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from kiln_connect.openapi_client.models.sol_operation_create_account import SOLOperationCreateAccount
from kiln_connect.openapi_client.models.sol_operation_create_account_with_seed import SOLOperationCreateAccountWithSeed
from kiln_connect.openapi_client.models.sol_operation_deactivate import SOLOperationDeactivate
from kiln_connect.openapi_client.models.sol_operation_delegate import SOLOperationDelegate
from kiln_connect.openapi_client.models.sol_operation_merge import SOLOperationMerge
from kiln_connect.openapi_client.models.sol_operation_redelegate import SOLOperationRedelegate
from kiln_connect.openapi_client.models.sol_operation_split import SOLOperationSplit
from kiln_connect.openapi_client.models.sol_operation_withdraw import SOLOperationWithdraw
from typing import Any, List
from pydantic import StrictStr, Field

GETSOLOPERATIONS200RESPONSEDATAINNER_ANY_OF_SCHEMAS = ["SOLOperationCreateAccount", "SOLOperationCreateAccountWithSeed", "SOLOperationDeactivate", "SOLOperationDelegate", "SOLOperationMerge", "SOLOperationRedelegate", "SOLOperationSplit", "SOLOperationWithdraw"]

class GetSolOperations200ResponseDataInner(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    # data type: SOLOperationCreateAccountWithSeed
    anyof_schema_1_validator: Optional[SOLOperationCreateAccountWithSeed] = None
    # data type: SOLOperationCreateAccount
    anyof_schema_2_validator: Optional[SOLOperationCreateAccount] = None
    # data type: SOLOperationDelegate
    anyof_schema_3_validator: Optional[SOLOperationDelegate] = None
    # data type: SOLOperationDeactivate
    anyof_schema_4_validator: Optional[SOLOperationDeactivate] = None
    # data type: SOLOperationRedelegate
    anyof_schema_5_validator: Optional[SOLOperationRedelegate] = None
    # data type: SOLOperationSplit
    anyof_schema_6_validator: Optional[SOLOperationSplit] = None
    # data type: SOLOperationWithdraw
    anyof_schema_7_validator: Optional[SOLOperationWithdraw] = None
    # data type: SOLOperationMerge
    anyof_schema_8_validator: Optional[SOLOperationMerge] = None
    actual_instance: Any
    any_of_schemas: List[str] = Field(GETSOLOPERATIONS200RESPONSEDATAINNER_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        error_messages = []
        # validate data type: SOLOperationCreateAccountWithSeed
        if type(v) is not SOLOperationCreateAccountWithSeed:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationCreateAccountWithSeed`")
        else:
            return v

        # validate data type: SOLOperationCreateAccount
        if type(v) is not SOLOperationCreateAccount:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationCreateAccount`")
        else:
            return v

        # validate data type: SOLOperationDelegate
        if type(v) is not SOLOperationDelegate:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationDelegate`")
        else:
            return v

        # validate data type: SOLOperationDeactivate
        if type(v) is not SOLOperationDeactivate:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationDeactivate`")
        else:
            return v

        # validate data type: SOLOperationRedelegate
        if type(v) is not SOLOperationRedelegate:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationRedelegate`")
        else:
            return v

        # validate data type: SOLOperationSplit
        if type(v) is not SOLOperationSplit:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationSplit`")
        else:
            return v

        # validate data type: SOLOperationWithdraw
        if type(v) is not SOLOperationWithdraw:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationWithdraw`")
        else:
            return v

        # validate data type: SOLOperationMerge
        if type(v) is not SOLOperationMerge:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SOLOperationMerge`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetSolOperations200ResponseDataInner with anyOf schemas: SOLOperationCreateAccount, SOLOperationCreateAccountWithSeed, SOLOperationDeactivate, SOLOperationDelegate, SOLOperationMerge, SOLOperationRedelegate, SOLOperationSplit, SOLOperationWithdraw. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_json(cls, json_str: str) -> GetSolOperations200ResponseDataInner:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        # anyof_schema_1_validator: Optional[SOLOperationCreateAccountWithSeed] = None
        try:
            instance.actual_instance = SOLOperationCreateAccountWithSeed.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[SOLOperationCreateAccount] = None
        try:
            instance.actual_instance = SOLOperationCreateAccount.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[SOLOperationDelegate] = None
        try:
            instance.actual_instance = SOLOperationDelegate.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[SOLOperationDeactivate] = None
        try:
            instance.actual_instance = SOLOperationDeactivate.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_5_validator: Optional[SOLOperationRedelegate] = None
        try:
            instance.actual_instance = SOLOperationRedelegate.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_6_validator: Optional[SOLOperationSplit] = None
        try:
            instance.actual_instance = SOLOperationSplit.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_7_validator: Optional[SOLOperationWithdraw] = None
        try:
            instance.actual_instance = SOLOperationWithdraw.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_8_validator: Optional[SOLOperationMerge] = None
        try:
            instance.actual_instance = SOLOperationMerge.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetSolOperations200ResponseDataInner with anyOf schemas: SOLOperationCreateAccount, SOLOperationCreateAccountWithSeed, SOLOperationDeactivate, SOLOperationDelegate, SOLOperationMerge, SOLOperationRedelegate, SOLOperationSplit, SOLOperationWithdraw. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

