# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from kiln_connect.openapi_client.models.xtz_cycle_reward import XTZCycleReward
from kiln_connect.openapi_client.models.xtz_daily_reward import XTZDailyReward
from typing import Any, List
from pydantic import StrictStr, Field

GETXTZREWARDS200RESPONSEDATAINNER_ANY_OF_SCHEMAS = ["XTZCycleReward", "XTZDailyReward"]

class GetXtzRewards200ResponseDataInner(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    # data type: XTZDailyReward
    anyof_schema_1_validator: Optional[XTZDailyReward] = None
    # data type: XTZCycleReward
    anyof_schema_2_validator: Optional[XTZCycleReward] = None
    actual_instance: Any
    any_of_schemas: List[str] = Field(GETXTZREWARDS200RESPONSEDATAINNER_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        error_messages = []
        # validate data type: XTZDailyReward
        if type(v) is not XTZDailyReward:
            error_messages.append(f"Error! Input type `{type(v)}` is not `XTZDailyReward`")
        else:
            return v

        # validate data type: XTZCycleReward
        if type(v) is not XTZCycleReward:
            error_messages.append(f"Error! Input type `{type(v)}` is not `XTZCycleReward`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetXtzRewards200ResponseDataInner with anyOf schemas: XTZCycleReward, XTZDailyReward. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_json(cls, json_str: str) -> GetXtzRewards200ResponseDataInner:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        # anyof_schema_1_validator: Optional[XTZDailyReward] = None
        try:
            instance.actual_instance = XTZDailyReward.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[XTZCycleReward] = None
        try:
            instance.actual_instance = XTZCycleReward.from_json(json_str)
            return instance
        except ValidationError as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GetXtzRewards200ResponseDataInner with anyOf schemas: XTZCycleReward, XTZDailyReward. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

