# coding: utf-8

"""
    Kiln API Docs (dev)

    This API provides reporting staking data on various protocols as well as network wide data, staking transaction crafting features and so on. In order to use it, you should first get an API token from your Kiln dashboard (applications section). If you don't have access to our dashboard, please get in touch at hello@kiln.fi. Once you have your API token, you can set it as a bearer token in your request headers.  ### Backward Compatibility  This is an experimental specification used for development and testing, do not rely on what is here unless you know the implications.  The official Kiln API specification following backward compatible changes can be found [here](/).  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: contact@kiln.fi
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import unittest
import datetime

import kiln_connect.openapi_client
from kiln_connect.openapi_client.models.atomtx_status import ATOMTxStatus  # noqa: E501
from kiln_connect.openapi_client.rest import ApiException

class TestATOMTxStatus(unittest.TestCase):
    """ATOMTxStatus unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test ATOMTxStatus
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `ATOMTxStatus`
        """
        model = kiln_connect.openapi_client.models.atomtx_status.ATOMTxStatus()  # noqa: E501
        if include_optional :
            return ATOMTxStatus(
                status = 'success', 
                receipt = {"height":16007296,"txIndex":0,"hash":"2B4F732E12D5D5AF1F907AD03B199167A718EDC6201DE5713143AB80990420CB","code":0,"events":[{"type":"coin_spent","attributes":[{"key":"spender","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"},{"key":"amount","value":"5000uatom"}]},{"type":"coin_received","attributes":[{"key":"receiver","value":"cosmos17xpfvakm2amg962yls6f84z3kell8c5lserqta"},{"key":"amount","value":"5000uatom"}]},{"type":"transfer","attributes":[{"key":"recipient","value":"cosmos17xpfvakm2amg962yls6f84z3kell8c5lserqta"},{"key":"sender","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"},{"key":"amount","value":"5000uatom"}]},{"type":"message","attributes":[{"key":"sender","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"}]},{"type":"tx","attributes":[{"key":"fee","value":"5000uatom"},{"key":"fee_payer","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"}]},{"type":"tx","attributes":[{"key":"acc_seq","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev/33"}]},{"type":"tx","attributes":[{"key":"signature","value":"GR+HpU3Or7arml8RKhNETKN+SaAp5TG7ITAf1y6dOQMEx2PMpal2CmMdyFcF3WsItQ9f/31d6Nc7LOvR9MO2oA=="}]},{"type":"message","attributes":[{"key":"action","value":"/cosmos.staking.v1beta1.MsgDelegate"}]},{"type":"coin_spent","attributes":[{"key":"spender","value":"cosmos1jv65s3grqf6v6jl3dp4t6c9t9rk99cd88lyufl"},{"key":"amount","value":"5uatom"}]},{"type":"coin_received","attributes":[{"key":"receiver","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"},{"key":"amount","value":"5uatom"}]},{"type":"transfer","attributes":[{"key":"recipient","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"},{"key":"sender","value":"cosmos1jv65s3grqf6v6jl3dp4t6c9t9rk99cd88lyufl"},{"key":"amount","value":"5uatom"}]},{"type":"message","attributes":[{"key":"sender","value":"cosmos1jv65s3grqf6v6jl3dp4t6c9t9rk99cd88lyufl"}]},{"type":"withdraw_rewards","attributes":[{"key":"amount","value":"5uatom"},{"key":"validator","value":"cosmosvaloper16ys0eg935mkqpkydkgfcj9age2au8l96naere9"}]},{"type":"coin_spent","attributes":[{"key":"spender","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"},{"key":"amount","value":"100000uatom"}]},{"type":"coin_received","attributes":[{"key":"receiver","value":"cosmos1fl48vsnmsdzcv85q5d2q4z5ajdha8yu34mf0eh"},{"key":"amount","value":"100000uatom"}]},{"type":"delegate","attributes":[{"key":"validator","value":"cosmosvaloper16ys0eg935mkqpkydkgfcj9age2au8l96naere9"},{"key":"amount","value":"100000uatom"},{"key":"new_shares","value":"100000.000000000000000000"}]},{"type":"message","attributes":[{"key":"module","value":"staking"},{"key":"sender","value":"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev"}]}],"rawLog":"[{\"events\":[{\"type\":\"coin_received\",\"attributes\":[{\"key\":\"receiver\",\"value\":\"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev\"},{\"key\":\"amount\",\"value\":\"5uatom\"},{\"key\":\"receiver\",\"value\":\"cosmos1fl48vsnmsdzcv85q5d2q4z5ajdha8yu34mf0eh\"},{\"key\":\"amount\",\"value\":\"100000uatom\"}]},{\"type\":\"coin_spent\",\"attributes\":[{\"key\":\"spender\",\"value\":\"cosmos1jv65s3grqf6v6jl3dp4t6c9t9rk99cd88lyufl\"},{\"key\":\"amount\",\"value\":\"5uatom\"},{\"key\":\"spender\",\"value\":\"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev\"},{\"key\":\"amount\",\"value\":\"100000uatom\"}]},{\"type\":\"delegate\",\"attributes\":[{\"key\":\"validator\",\"value\":\"cosmosvaloper16ys0eg935mkqpkydkgfcj9age2au8l96naere9\"},{\"key\":\"amount\",\"value\":\"100000uatom\"},{\"key\":\"new_shares\",\"value\":\"100000.000000000000000000\"}]},{\"type\":\"message\",\"attributes\":[{\"key\":\"action\",\"value\":\"/cosmos.staking.v1beta1.MsgDelegate\"},{\"key\":\"sender\",\"value\":\"cosmos1jv65s3grqf6v6jl3dp4t6c9t9rk99cd88lyufl\"},{\"key\":\"module\",\"value\":\"staking\"},{\"key\":\"sender\",\"value\":\"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev\"}]},{\"type\":\"transfer\",\"attributes\":[{\"key\":\"recipient\",\"value\":\"cosmos19c9fdh488vqjclltwp68jm50ydwyh36jqeatev\"},{\"key\":\"sender\",\"value\":\"cosmos1jv65s3grqf6v6jl3dp4t6c9t9rk99cd88lyufl\"},{\"key\":\"amount\",\"value\":\"5uatom\"}]},{\"type\":\"withdraw_rewards\",\"attributes\":[{\"key\":\"amount\",\"value\":\"5uatom\"},{\"key\":\"validator\",\"value\":\"cosmosvaloper16ys0eg935mkqpkydkgfcj9age2au8l96naere9\"}]}]}]","tx":{"0":10,"1":160,"2":1,"3":10,"4":157,"5":1,"6":10,"7":35,"8":47,"9":99,"10":111,"11":115,"12":109,"13":111,"14":115,"15":46,"16":115,"17":116,"18":97,"19":107,"20":105,"21":110,"22":103,"23":46,"24":118,"25":49,"26":98,"27":101,"28":116,"29":97,"30":49,"31":46,"32":77,"33":115,"34":103,"35":68,"36":101,"37":108,"38":101,"39":103,"40":97,"41":116,"42":101,"43":18,"44":118,"45":10,"46":45,"47":99,"48":111,"49":115,"50":109,"51":111,"52":115,"53":49,"54":57,"55":99,"56":57,"57":102,"58":100,"59":104,"60":52,"61":56,"62":56,"63":118,"64":113,"65":106,"66":99,"67":108,"68":108,"69":116,"70":119,"71":112,"72":54,"73":56,"74":106,"75":109,"76":53,"77":48,"78":121,"79":100,"80":119,"81":121,"82":104,"83":51,"84":54,"85":106,"86":113,"87":101,"88":97,"89":116,"90":101,"91":118,"92":18,"93":52,"94":99,"95":111,"96":115,"97":109,"98":111,"99":115,"100":118,"101":97,"102":108,"103":111,"104":112,"105":101,"106":114,"107":49,"108":54,"109":121,"110":115,"111":48,"112":101,"113":103,"114":57,"115":51,"116":53,"117":109,"118":107,"119":113,"120":112,"121":107,"122":121,"123":100,"124":107,"125":103,"126":102,"127":99,"128":106,"129":57,"130":97,"131":103,"132":101,"133":50,"134":97,"135":117,"136":56,"137":108,"138":57,"139":54,"140":110,"141":97,"142":101,"143":114,"144":101,"145":57,"146":26,"147":15,"148":10,"149":5,"150":117,"151":97,"152":116,"153":111,"154":109,"155":18,"156":6,"157":49,"158":48,"159":48,"160":48,"161":48,"162":48,"163":18,"164":103,"165":10,"166":80,"167":10,"168":70,"169":10,"170":31,"171":47,"172":99,"173":111,"174":115,"175":109,"176":111,"177":115,"178":46,"179":99,"180":114,"181":121,"182":112,"183":116,"184":111,"185":46,"186":115,"187":101,"188":99,"189":112,"190":50,"191":53,"192":54,"193":107,"194":49,"195":46,"196":80,"197":117,"198":98,"199":75,"200":101,"201":121,"202":18,"203":35,"204":10,"205":33,"206":3,"207":156,"208":228,"209":123,"210":42,"211":129,"212":61,"213":19,"214":135,"215":97,"216":49,"217":169,"218":195,"219":190,"220":119,"221":232,"222":196,"223":175,"224":164,"225":158,"226":148,"227":135,"228":68,"229":171,"230":190,"231":225,"232":31,"233":147,"234":158,"235":42,"236":66,"237":15,"238":70,"239":18,"240":4,"241":10,"242":2,"243":8,"244":1,"245":24,"246":33,"247":18,"248":19,"249":10,"250":13,"251":10,"252":5,"253":117,"254":97,"255":116,"256":111,"257":109,"258":18,"259":4,"260":53,"261":48,"262":48,"263":48,"264":16,"265":224,"266":167,"267":18,"268":26,"269":64,"270":25,"271":31,"272":135,"273":165,"274":77,"275":206,"276":175,"277":182,"278":171,"279":154,"280":95,"281":17,"282":42,"283":19,"284":68,"285":76,"286":163,"287":126,"288":73,"289":160,"290":41,"291":229,"292":49,"293":187,"294":33,"295":48,"296":31,"297":215,"298":46,"299":157,"300":57,"301":3,"302":4,"303":199,"304":99,"305":204,"306":165,"307":169,"308":118,"309":10,"310":99,"311":29,"312":200,"313":87,"314":5,"315":221,"316":107,"317":8,"318":181,"319":15,"320":95,"321":255,"322":125,"323":93,"324":232,"325":215,"326":59,"327":44,"328":235,"329":209,"330":244,"331":195,"332":182,"333":160},"gasUsed":167798,"gasWanted":300000}
            )
        else :
            return ATOMTxStatus(
        )
        """

    def testATOMTxStatus(self):
        """Test ATOMTxStatus"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
